Index: /branches/HM-10.0-dev-SHM/source/Lib/TLibCommon/TComDataCU.cpp
===================================================================
--- /branches/HM-10.0-dev-SHM/source/Lib/TLibCommon/TComDataCU.cpp	(revision 94)
+++ /branches/HM-10.0-dev-SHM/source/Lib/TLibCommon/TComDataCU.cpp	(revision 95)
@@ -1835,5 +1835,5 @@
   {
     Int refIdxL0 = cMvFieldL0.getRefIdx();
-    if(getSlice()->getRefPic(REF_PIC_LIST_0, refIdxL0)->getIsILR())
+    if(getSlice()->getRefPic(REF_PIC_LIST_0, refIdxL0)->isILR())
     {
       checkZeroMVILR &= (cMvFieldL0.getHor() == 0 && cMvFieldL0.getVer() == 0);
@@ -1843,5 +1843,5 @@
   {
     Int refIdxL1  = cMvFieldL1.getRefIdx();
-    if(getSlice()->getRefPic(REF_PIC_LIST_1, refIdxL1)->getIsILR())
+    if(getSlice()->getRefPic(REF_PIC_LIST_1, refIdxL1)->isILR())
     {
       checkZeroMVILR &= (cMvFieldL1.getHor() == 0 && cMvFieldL1.getVer() == 0);
@@ -1859,5 +1859,5 @@
   Bool checkZeroMVILR = true;
 
-  if(getSlice()->getRefPic(eRefPicList, iRefIdx)->getIsILR())
+  if(getSlice()->getRefPic(eRefPicList, iRefIdx)->isILR())
   {
     AMVPInfo* pcAMVPInfo = getCUMvField(eRefPicList)->getAMVPInfo();
Index: /branches/HM-10.0-dev-SHM/source/Lib/TLibCommon/TComPic.h
===================================================================
--- /branches/HM-10.0-dev-SHM/source/Lib/TLibCommon/TComPic.h	(revision 94)
+++ /branches/HM-10.0-dev-SHM/source/Lib/TLibCommon/TComPic.h	(revision 95)
@@ -124,5 +124,5 @@
 #endif
 #if REF_IDX_ME_ZEROMV || ENCODER_FAST_MODE || REF_IDX_MFM
-  Bool          getIsILR( UInt refLayer = 0 )   {return (getIsLongTerm() && m_layerId == refLayer);}
+  Bool          isILR( UInt refLayer = 0 )   {return (getIsLongTerm() && m_layerId == refLayer);}
 #endif
 
Index: /branches/HM-10.0-dev-SHM/source/Lib/TLibCommon/TComPrediction.cpp
===================================================================
--- /branches/HM-10.0-dev-SHM/source/Lib/TLibCommon/TComPrediction.cpp	(revision 94)
+++ /branches/HM-10.0-dev-SHM/source/Lib/TLibCommon/TComPrediction.cpp	(revision 95)
@@ -495,5 +495,5 @@
 
 #if REF_IDX_ME_ZEROMV
-  assert( ( pcCU->getSlice()->getRefPic(eRefPicList, iRefIdx)->getIsILR() && cMv.getHor() == 0 && cMv.getVer() == 0 ) || pcCU->getSlice()->getRefPic(eRefPicList, iRefIdx)->getIsILR() == false );
+  assert( ( pcCU->getSlice()->getRefPic(eRefPicList, iRefIdx)->isILR() && cMv.getHor() == 0 && cMv.getVer() == 0 ) || pcCU->getSlice()->getRefPic(eRefPicList, iRefIdx)->isILR() == false );
 #endif
 
Index: /branches/HM-10.0-dev-SHM/source/Lib/TLibCommon/TypeDef.h
===================================================================
--- /branches/HM-10.0-dev-SHM/source/Lib/TLibCommon/TypeDef.h	(revision 94)
+++ /branches/HM-10.0-dev-SHM/source/Lib/TLibCommon/TypeDef.h	(revision 95)
@@ -57,5 +57,5 @@
 
 #define AVC_BASE                         0      ///< YUV BL reading for AVC base SVC
-#define REF_IDX_FRAMEWORK                0      ///< inter-layer reference framework
+#define REF_IDX_FRAMEWORK                1      ///< inter-layer reference framework
 
 #if SVC_UPSAMPLING
Index: /branches/HM-10.0-dev-SHM/source/Lib/TLibEncoder/TEncGOP.cpp
===================================================================
--- /branches/HM-10.0-dev-SHM/source/Lib/TLibEncoder/TEncGOP.cpp	(revision 94)
+++ /branches/HM-10.0-dev-SHM/source/Lib/TLibEncoder/TEncGOP.cpp	(revision 95)
@@ -571,5 +571,5 @@
       for(Int colIdx = 0; colIdx < pcSlice->getNumRefIdx( RefPicList(1 - ColFromL0Flag) ); colIdx++) 
       { 
-        if( pcSlice->getRefPic( RefPicList(1 - ColFromL0Flag), colIdx)->getIsILR() ) 
+        if( pcSlice->getRefPic( RefPicList(1 - ColFromL0Flag), colIdx)->isILR() ) 
         { 
           ColRefIdx = colIdx; 
@@ -584,5 +584,5 @@
         for(Int colIdx = 0; colIdx < pcSlice->getNumRefIdx( RefPicList(1 - ColFromL0Flag) ); colIdx++) 
         { 
-          if( pcSlice->getRefPic( RefPicList(1 - ColFromL0Flag), colIdx)->getIsILR() ) 
+          if( pcSlice->getRefPic( RefPicList(1 - ColFromL0Flag), colIdx)->isILR() ) 
           { 
             ColRefIdx = colIdx; 
Index: /branches/HM-10.0-dev-SHM/source/Lib/TLibEncoder/TEncSearch.cpp
===================================================================
--- /branches/HM-10.0-dev-SHM/source/Lib/TLibEncoder/TEncSearch.cpp	(revision 94)
+++ /branches/HM-10.0-dev-SHM/source/Lib/TLibEncoder/TEncSearch.cpp	(revision 95)
@@ -3289,5 +3289,5 @@
 #if (ENCODER_FAST_MODE)
         TComPic* pcPic    = pcCU->getSlice()->getRefPic( eRefPicList, iRefIdxTemp );
-        if( !testILR && pcPic->getIsILR() && (ePartSize == SIZE_2Nx2N) ) 
+        if( !testILR && pcPic->isILR() && (ePartSize == SIZE_2Nx2N) ) 
         {
           continue;
@@ -3533,6 +3533,8 @@
         Bool     testIter = true;
         TComPic* pcPic    = pcCU->getSlice()->getRefPic( RefPicList(1 - iRefList), iRefIdxBi[1 - iRefList] );
-        if(pcPic->getIsILR() && (ePartSize == SIZE_2Nx2N))
+        if(pcPic->isILR() && (ePartSize == SIZE_2Nx2N))
+        {
           testIter = false;  //the fixed part is ILR, skip this iteration       
+        }
         if(testIter)
         {
@@ -3544,10 +3546,12 @@
         {
 #if (ENCODER_FAST_MODE)
-            Bool testRefIdx = true;
-            pcPic           = pcCU->getSlice()->getRefPic( RefPicList(iRefList) , iRefIdxTemp );
-            if(pcPic->getIsILR() && (ePartSize == SIZE_2Nx2N))
-              testRefIdx = false;  //the refined part is ILR, skip this reference pic           
-            if(testRefIdx)
-            {
+          Bool testRefIdx = true;
+          pcPic           = pcCU->getSlice()->getRefPic( RefPicList(iRefList) , iRefIdxTemp );
+          if(pcPic->isILR() && (ePartSize == SIZE_2Nx2N))
+          {
+            testRefIdx = false;  //the refined part is ILR, skip this reference pic           
+          }
+          if(testRefIdx)
+          {
 #endif
           uiBitsTemp = uiMbBits[2] + uiMotBits[1-iRefList];
@@ -3585,7 +3589,7 @@
           }
 #if (ENCODER_FAST_MODE)
-            }
-#endif
           }
+#endif
+        }
 #if (ENCODER_FAST_MODE)
         } // for loop-iRefIdxTemp
@@ -4208,5 +4212,5 @@
   //  Do integer search
 #if REF_IDX_ME_ZEROMV
-  if( pcCU->getSlice()->getRefPic( eRefPicList, iRefIdxPred )->getIsILR())  //ILR reference pic 
+  if( pcCU->getSlice()->getRefPic( eRefPicList, iRefIdxPred )->isILR())  //ILR reference pic 
   {
     rcMv.setZero();  //use Mv(0, 0) for integer ME 
@@ -4241,5 +4245,5 @@
   {
 #if REF_IDX_ME_ZEROMV
-    if( pcCU->getSlice()->getRefPic( eRefPicList, iRefIdxPred )->getIsILR())  //ILR reference pic
+    if( pcCU->getSlice()->getRefPic( eRefPicList, iRefIdxPred )->isILR())  //ILR reference pic
     {
       xPatternSearchFracDIFMv0( pcCU, pcPatternKey, piRefY, iRefStride, &rcMv, cMvHalf, cMvQter, ruiCost, bBi );
@@ -6214,5 +6218,5 @@
     Bool foundILR    = false;
     for( Int refIdx = 0; refIdx < pcCU->getSlice()->getNumRefIdx(eRefPicList); refIdx++ )
-      if( pcCU->getSlice()->getRefPic(eRefPicList, refIdx)->getIsILR() )
+      if( pcCU->getSlice()->getRefPic(eRefPicList, refIdx)->isILR() )
       {
         iRefIdxTemp = refIdx;