Index: branches/HTM-3.1-LG/source/Lib/TLibCommon/TComDataCU.cpp
===================================================================
--- branches/HTM-3.1-LG/source/Lib/TLibCommon/TComDataCU.cpp	(revision 98)
+++ branches/HTM-3.1-LG/source/Lib/TLibCommon/TComDataCU.cpp	(revision 99)
@@ -3467,4 +3467,9 @@
   TComMv  acPdmMv       [2];
   Int     aiPdmRefIdx   [2] = {-1, -1};
+
+#if LGE_DVMCP
+  acPdmMv[0].m_bDvMcp = acPdmMv[1].m_bDvMcp = false; 
+#endif
+
 #if QC_MULTI_DIS_CAN
   DisInfo cDisInfo;
@@ -3472,5 +3477,5 @@
   if(!bNoPdmMerge)
   {
-#if USE_DVMCP
+#if LGE_DVMCP
     getDisMvpCand2(uiPUIdx, uiAbsPartIdx, &cDisInfo, true );
 #else
@@ -3543,5 +3548,5 @@
       pcCULeft->getMvField( pcCULeft, uiLeftPartIdx, REF_PIC_LIST_1, pcMvFieldNeighbours[(iCount<<1)+1] );
     }
-#if USE_DVMCP
+#if LGE_DVMCP
     pcMvFieldNeighbours[iCount<<1    ].getMv().m_bDvMcp = false;
     pcMvFieldNeighbours[(iCount<<1)+1].getMv().m_bDvMcp = false;
@@ -3619,5 +3624,5 @@
       pcCUAbove->getMvField( pcCUAbove, uiAbovePartIdx, REF_PIC_LIST_1, pcMvFieldNeighbours[(iCount<<1)+1] );
     }
-#if USE_DVMCP
+#if LGE_DVMCP
     pcMvFieldNeighbours[iCount<<1    ].getMv().m_bDvMcp = false;
     pcMvFieldNeighbours[(iCount<<1)+1].getMv().m_bDvMcp = false;
@@ -3690,5 +3695,5 @@
       pcCUAboveRight->getMvField( pcCUAboveRight, uiAboveRightPartIdx, REF_PIC_LIST_1, pcMvFieldNeighbours[(iCount<<1)+1] );
     }
-#if USE_DVMCP
+#if LGE_DVMCP
     pcMvFieldNeighbours[iCount<<1    ].getMv().m_bDvMcp = false;
     pcMvFieldNeighbours[(iCount<<1)+1].getMv().m_bDvMcp = false;
@@ -3758,5 +3763,5 @@
       pcCULeftBottom->getMvField( pcCULeftBottom, uiLeftBottomPartIdx, REF_PIC_LIST_1, pcMvFieldNeighbours[(iCount<<1)+1] );
     }
-#if USE_DVMCP
+#if LGE_DVMCP
     pcMvFieldNeighbours[iCount<<1    ].getMv().m_bDvMcp = false;
     pcMvFieldNeighbours[(iCount<<1)+1].getMv().m_bDvMcp = false;
@@ -3835,5 +3840,5 @@
         pcCUAboveLeft->getMvField( pcCUAboveLeft, uiAboveLeftPartIdx, REF_PIC_LIST_1, pcMvFieldNeighbours[(iCount<<1)+1] );
       }
-#if USE_DVMCP
+#if LGE_DVMCP
       pcMvFieldNeighbours[iCount<<1    ].getMv().m_bDvMcp = false;
       pcMvFieldNeighbours[(iCount<<1)+1].getMv().m_bDvMcp = false;
@@ -3955,5 +3960,5 @@
         puhInterDirNeighbours[uiArrayAddr] = 1;
       }
-#if USE_DVMCP
+#if LGE_DVMCP
       pcMvFieldNeighbours[uiArrayAddr<<1    ].getMv().m_bDvMcp = false;
       pcMvFieldNeighbours[(uiArrayAddr<<1)+1].getMv().m_bDvMcp = false;
@@ -4754,5 +4759,5 @@
 }
 
-#if USE_DVMCP
+#if LGE_DVMCP
 Void TComDataCU::getDisMvpCand2( UInt uiPartIdx, UInt uiPartAddr,DisInfo* pDInfo, Bool bMerge, RefPicList eRefPicList0, Int iRefIdx0 )
 {
@@ -4813,13 +4818,4 @@
             bDvMcpIsFound = true;
           }
-#if USE_DVMCP_MSG
-          //printf("skipped %d =%d, curCUAddr=%d, leftCUAddr=%d\n",DVFROM_LEFT, iList, getAddr(), pcTmpCU->getAddr() );
-          aiRefPOC     [iList][DVFROM_LEFT] = pcTmpCU->getCUMvField(eRefPicList)->getRefIdx(uiIdx);
-          if( aiRefPOC[iList][DVFROM_LEFT]<0 )
-          {
-            printf("error\n");
-          }
-          //aiRefPOC     [iList][DVFROM_LEFT] = pcTmpCU->getSlice()->getRefPOC( eRefPicList, );
-#endif
         }
       }
@@ -4860,12 +4856,4 @@
             bDvMcpIsFound = true;
           }
-#if USE_DVMCP_MSG
-          //printf("skipped %d =%d, curCUAddr=%d, leftCUAddr=%d\n",DVFROM_ABOVE, iList, getAddr(), pcTmpCU->getAddr() );
-          aiRefPOC     [iList][DVFROM_ABOVE] = pcTmpCU->getCUMvField(eRefPicList)->getRefIdx(uiIdx);
-          if( aiRefPOC[iList][DVFROM_ABOVE]<0 )
-          {
-            printf("error\n");
-          }
-#endif
         }
       }
@@ -4905,8 +4893,4 @@
             bDvMcpIsFound = true;
           }
-#if USE_DVMCP_MSG
-          //printf("skipped %d =%d, curCUAddr=%d, leftCUAddr=%d\n",DVFROM_ABOVERIGHT, iList, getAddr(), pcTmpCU->getAddr() );
-          aiRefPOC     [iList][DVFROM_ABOVERIGHT] = pcTmpCU->getCUMvField(eRefPicList)->getRefIdx(uiIdx);
-#endif
         }
       }
@@ -4946,8 +4930,4 @@
             bDvMcpIsFound = true;
           }
-#if USE_DVMCP_MSG
-          //printf("skipped %d =%d, curCUAddr=%d, leftCUAddr=%d\n",DVFROM_LEFTBELOW, iList, getAddr(), pcTmpCU->getAddr() );
-          aiRefPOC     [iList][DVFROM_LEFTBELOW] = pcTmpCU->getCUMvField(eRefPicList)->getRefIdx(uiIdx);
-#endif
         }
       }
@@ -4989,8 +4969,4 @@
             bDvMcpIsFound = true;
           }
-#if USE_DVMCP_MSG
-          aiRefPOC     [iList][DVFROM_ABOVELEFT] = pcTmpCU->getCUMvField(eRefPicList)->getRefIdx(uiIdx);
-          //printf("skipped %d =%d, curCUAddr=%d, leftCUAddr=%d\n",DVFROM_ABOVELEFT, iList, getAddr(), pcTmpCU->getAddr() );
-#endif
         }
       }
@@ -5211,5 +5187,5 @@
   if(m_pcSlice->getSPS()->getViewId() && m_pcSlice->getSPS()->getMultiviewMvPredMode())
   {
-#if USE_DVMCP
+#if LGE_DVMCP
     getDisMvpCand2(uiPartIdx, uiPartAddr, &cDisInfo, false, eRefPicList, iRefIdx );
 #else
@@ -5640,5 +5616,5 @@
   {
     TComMv cMvPred = pcTmpCU->getCUMvField(eRefPicList)->getMv(uiIdx);
-#if USE_DVMCP
+#if LGE_DVMCP
     cMvPred.m_bDvMcp = false;
 #endif 
@@ -5677,5 +5653,5 @@
     {
       TComMv cMvPred = pcTmpCU->getCUMvField(eRefPicList2nd)->getMv(uiIdx);
-#if USE_DVMCP
+#if LGE_DVMCP
       cMvPred.m_bDvMcp = false;
 #endif
@@ -5820,5 +5796,5 @@
     {
       TComMv cMvPred = pcTmpCU->getCUMvField(eRefPicList2nd)->getMv(uiIdx);
-#if USE_DVMCP
+#if LGE_DVMCP
       cMvPred.m_bDvMcp = false;
 #endif
@@ -5850,5 +5826,5 @@
       rcMv = cMvPred.scaleMv( iScale );
     }
-#if USE_DVMCP
+#if LGE_DVMCP
     rcMv.m_bDvMcp = false;
 #endif
@@ -5877,5 +5853,5 @@
       rcMv = cMvPred.scaleMv( iScale );
     }
-#if USE_DVMCP
+#if LGE_DVMCP
     rcMv.m_bDvMcp = false;
 #endif
@@ -5890,5 +5866,5 @@
 Bool TComDataCU::xGetColDisMV( RefPicList eRefPicList, Int refidx, Int uiCUAddr, Int uiPartUnitIdx, TComMv& rcMv , Int & iTargetViewIdx, Int & iStartViewIdx )
 {
-#if USE_DVMCP
+#if LGE_DVMCP
   Int  iDvMcpDispX[2] = {-1,};
   Bool bDvMcpFlag [2] = { false, }; 
@@ -5909,5 +5885,5 @@
     return false;
   }
-#if USE_DVMCP
+#if LGE_DVMCP
   Bool bColIsSkipped = pColCU->isSkipped( uiAbsPartAddr );
 #endif
@@ -5929,5 +5905,5 @@
     if ( iColViewIdx    == iColRefViewIdx ) // temporal vector
     {
-#if USE_DVMCP
+#if LGE_DVMCP
       if( iColViewIdx >0 )
       {
@@ -5947,5 +5923,5 @@
     {
 	  rcMv = pColCU->getCUMvField(eColRefPicList)->getMv(uiAbsPartAddr);
-#if USE_DVMCP
+#if LGE_DVMCP
     rcMv.m_bDvMcp = false;
 #endif
@@ -5956,5 +5932,5 @@
   }
 
-#if USE_DVMCP
+#if LGE_DVMCP
   for( Int ilist=0 ; ilist<2 ; ilist++ )
   {
@@ -7078,5 +7054,5 @@
    PartSize m_peSaved =  getPartitionSize( 0 );
    m_pePartSize[0] =  SIZE_2Nx2N;
-#if USE_DVMCP
+#if LGE_DVMCP
    getDisMvpCand2( 0, 0,  &cDisInfo, true );
 #else
Index: branches/HTM-3.1-LG/source/Lib/TLibCommon/TComDataCU.h
===================================================================
--- branches/HTM-3.1-LG/source/Lib/TLibCommon/TComDataCU.h	(revision 98)
+++ branches/HTM-3.1-LG/source/Lib/TLibCommon/TComDataCU.h	(revision 99)
@@ -525,5 +525,5 @@
   Int           getPdmMergeCandidateDisCan( UInt uiPartIdx, Int* paiPdmRefIdx, TComMv* pacPdmMv, DisInfo* pDInfo );
   Void          getDisMvpCand        ( UInt uiPartIdx, UInt uiPartAddr, DisInfo* pDInfo );
-#if USE_DVMCP
+#if LGE_DVMCP
   Void          getDisMvpCand2( UInt uiPartIdx, UInt uiPartAddr, DisInfo* pDInfo, Bool bMerge=false, RefPicList eRefPicList=REF_PIC_LIST_X, Int iRefIdx=-1 );
 #endif
Index: branches/HTM-3.1-LG/source/Lib/TLibCommon/TComDepthMapGenerator.cpp
===================================================================
--- branches/HTM-3.1-LG/source/Lib/TLibCommon/TComDepthMapGenerator.cpp	(revision 98)
+++ branches/HTM-3.1-LG/source/Lib/TLibCommon/TComDepthMapGenerator.cpp	(revision 99)
@@ -726,4 +726,8 @@
               paiPdmRefIdx  [ uiBaseRefListId ] = iPdmRefIdx;
               TComMv cMv(cBaseMvField.getHor(), cBaseMvField.getVer());
+#if LGE_DVMCP
+              cMv.m_bDvMcp = true;
+              cMv.m_iDvMcpDispX = pDInfo->m_acMvCand[0].getHor();
+#endif
               pcCU->clipMv( cMv );
               pacPdmMv      [ uiBaseRefListId ] = cMv;
@@ -831,5 +835,5 @@
 TComDepthMapGenerator::getDisCanPdmMvPred    ( TComDataCU*   pcCU, UInt uiPartIdx, RefPicList eRefPicList, Int iRefIdx, TComMv& rcMv, DisInfo* pDInfo, Bool bMerge )
 {
-#if USE_DVMCP
+#if LGE_DVMCP
   rcMv.m_bDvMcp = false;
 #endif
@@ -895,5 +899,5 @@
       {
         rcMv.set( cBaseMvField.getHor(), cBaseMvField.getVer() );
-#if USE_DVMCP
+#if LGE_DVMCP
         // save disparity vector when a merge candidate for IVMP is set as DV-MCP
         if( bMerge ) 
Index: branches/HTM-3.1-LG/source/Lib/TLibCommon/TComMv.h
===================================================================
--- branches/HTM-3.1-LG/source/Lib/TLibCommon/TComMv.h	(revision 98)
+++ branches/HTM-3.1-LG/source/Lib/TLibCommon/TComMv.h	(revision 99)
@@ -57,5 +57,5 @@
 public:
   
-#if USE_DVMCP
+#if LGE_DVMCP
   Bool  m_bDvMcp;       // is dv-mcp ?
   Int   m_iDvMcpDispX;  // disparity for dv-mcp
@@ -69,5 +69,5 @@
   m_iHor(0),
   m_iVer(0)
-#if USE_DVMCP
+#if LGE_DVMCP
   , m_bDvMcp(false)
   , m_iDvMcpDispX(0)
@@ -79,5 +79,5 @@
   m_iHor(iHor),
   m_iVer(iVer)
-#if USE_DVMCP
+#if LGE_DVMCP
   , m_bDvMcp(false)
   , m_iDvMcpDispX(0)
Index: branches/HTM-3.1-LG/source/Lib/TLibCommon/TypeDef.h
===================================================================
--- branches/HTM-3.1-LG/source/Lib/TLibCommon/TypeDef.h	(revision 98)
+++ branches/HTM-3.1-LG/source/Lib/TLibCommon/TypeDef.h	(revision 99)
@@ -66,13 +66,12 @@
 #define MTK_INTERVIEW_MERGE_A0049         1 //  JCT2-A0049 second part
 
-#if QC_MULTI_DIS_CAN                    // JCT2-A0126
-#define USE_DVMCP         0 
-
-#define DVFROM_LEFTBELOW  1
-#define DVFROM_LEFT       2
-#define DVFROM_ABOVERIGHT 3
-#define DVFROM_ABOVE      4
-#define DVFROM_ABOVELEFT  5
-#define DVFROM_COL        6
+#define LGE_DVMCP                         1 //  JCT2-A0126     
+#if LGE_DVMCP
+#define DVFROM_LEFTBELOW                  1
+#define DVFROM_LEFT                       2
+#define DVFROM_ABOVERIGHT                 3
+#define DVFROM_ABOVE                      4
+#define DVFROM_ABOVELEFT                  5
+#define DVFROM_COL                        6
 #endif
 